do
tempcounter = 0
led = 256*2
ws2812.init()
buffer = ws2812.newBuffer(led, 3)
buffer:fill(0, 0, 0)

st = function(dt, pos, sft)
	local dg = dig[dt]
	sft = sft or 0
	local state = pos*64+sft*8 or 0
	
	for i = 1, 8 do
		local digt = dg[i]
		if i%2 ~= 0 then
			for k = 0, 7 do	
				state = state +1
				local a = bit.isset(digt, k) and 10 or 0
				print(state, a)
				buffer:set(state, 0,0, a )	
			end
		else
			for k = 7, 0, -1 do	
				state = state +1
				local a = bit.isset(digt, k) and 10 or 0
				print(state, a)
				buffer:set(state, 0,0, a )	
			end	
		end
	end
	ws2812.write(buffer)
end
--st('0',0)
--st('1',1)
--st('2',2)
--st('3',3)

write = function(dt, color)
	color = color or colorall
	colorall = color
	local state = 0
	local wrt = function(d)
		local dg = dig[d]
		local function bufwr(digt, k)
			state = state +1
			local a = bit.isset(digt, k) and color or {0,0,0}
			buffer:set(state, a )	
		end
		for i = 1, 8 do
			local digt  = dg[i]
			local st, endd, inc = 0, 7, 1 
			if i%2 == 0 then
				st, endd, inc = 7, 0, -1
			end	
			for k =  st, endd, inc do	
				bufwr(digt, k)
			end
		end	
	end
	for i = 4, 1, -1 do
		local d = string.sub(dt, i,i)
		wrt(d)
	end
	ws2812.write(buffer)
end

pix = function( pixx, color )
	color = color or colorall
	for _, v in pairs(pixx) do
		buffer:set(v, color)
	end
		ws2812.write(buffer)
	end 
end

function gettime()
	tm = rtctime.epoch2cal(rtctime.get()+dat.tz*60*60)
	if tm['year']==1970 then return end
	if tm.hour > 5 and tm.hour < 20 then
		dat.colclock = {250,250,250}
		dat.coltemp = {250,250,10}
	else
		dat.colclock = {20,20,20}
		dat.coltemp = {20,20,1}
	end 

	local sh = ''..tm.hour
	local sm = ''..tm.min
	if #sh == 1 then sh = '0'.. sh end
	if #sm == 1 then sm = '0'.. sm end
	dat.lasttime = sh..sm
	if dat.mnow == dat.lasttime then
		return
	else
		dat.mnow = dat.lasttime
		print(sh..':'..sm)
		write(dat.lasttime)
	end
end

dotflag = false
dot = tmr.create()
dot:register(1000, tmr.ALARM_AUTO, function(t)
	tempcounter = tempcounter + 1
	if tempcounter > 7 then
		tempcounter = 0
		if dat.temp then
			return dofile('maketemp.lua')
		end
	end	
	gettime()
	if tm['year']==1970 then return end
	if dotflag then
		pix({131,133},{0,0,0})
		dotflag = false
	else
		pix({131,133})
		dotflag = true
	end
end)
dot:start()